src/Entity/Document.php
<?php

namespace App\Entity;

use App\Repository\AuthorDocumentRepository;
use App\Repository\DocumentRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Event\LifecycleEventArgs;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=DocumentRepository::class)
 * @ORM\HasLifecycleCallbacks()
 */
class Document
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private $docid;

    /**
     * @ORM\OneToMany(targetEntity=Version::class, mappedBy="document", orphanRemoval=true)
     */
    private $versions;

    /**
     * @ORM\OneToMany(targetEntity=AuthorDocument::class, mappedBy="document", cascade={"persist"})
     */
    private $authors;

    /**
     * @ORM\ManyToMany(targetEntity=Category::class, mappedBy="documents", cascade={"persist"})
     */
    private $categories;

    /**
     * @var Collection
     */
    private $regularAuthors;

    public function __construct()
    {
        $this->versions = new ArrayCollection();
        $this->authors = new ArrayCollection();
        $this->regularAuthors = new ArrayCollection();
        $this->categories = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getDocid(): ?string
    {
        return $this->docid;
    }

    public function setDocid(string $docid): self
    {
        $this->docid = $docid;

        return $this;
    }

    /**
     * @return Collection|Version[]
     */
    public function getVersions(): Collection
    {
        return $this->versions;
    }

    public function addVersion(Version $version): self
    {
        if (!$this->versions->contains($version)) {
            $this->versions[] = $version;
            $version->setDocument($this);
        }

        return $this;
    }

    public function removeVersion(Version $version): self
    {
        if ($this->versions->removeElement($version)) {
            // set the owning side to null (unless already changed)
            if ($version->getDocument() === $this) {
                $version->setDocument(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|AuthorDocument[]
     */
    public function getAuthors(): Collection
    {
        return $this->authors;
    }

    public function addAuthor(AuthorDocument $author): self
    {
        if (!$this->authors->contains($author)) {
            $this->authors[] = $author;
            $author->setDocument($this);
        }

        return $this;
    }

    public function removeAuthor(AuthorDocument $author): self
    {
        if ($this->authors->removeElement($author)) {
            // set the owning side to null (unless already changed)
            if ($author->getDocument() === $this) {
                $author->setDocument(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Category[]
     */
    public function getCategories(): Collection
    {
        return $this->categories;
    }

    public function addCategory(Category $category): self
    {
        if (!$this->categories->contains($category)) {
            $this->categories[] = $category;
            $category->addDocument($this);
        }

        return $this;
    }

    public function removeCategory(Category $category): self
    {
        if ($this->categories->removeElement($category)) {
            $category->removeDocument($this);
        }

        return $this;
    }

    public function __toString()
    {
        return $this->getTitle();
    }

    public function getLatestVersion(): Version
    {
        //TODO: Fix
        return $this->getVersions()->last();
    }

    public function getOldestVersion(): Version
    {
        //TODO: Fix
        return $this->getVersions()->first();
    }

    public function getCreationDate(): \DateTimeInterface
    {
        return $this->getOldestVersion()->getDate();
    }

    public function getRevisionDate(): \DateTimeInterface
    {
        return $this->getLatestVersion()->getDate();
    }

    public function getDate()
    {
        return $this->getCreationDate();
    }

    public function getIcon(): ?string
    {
        /** @var Category|false $category */
        $category = $this->getCategories()
            ->filter(function(Category $c) {
                return $c->getIcon() !== null;
            })
            ->first();

        if ($category) {
            return $category->getIcon();
        } else {
            return null;
        }
    }

    public function getMetaContentType(): ?string
    {
        /** @var Category|false $category */
        $category = $this->getCategories()
            ->filter(function(Category $c) {
                return $c->getMetaContentType() !== null;
            })
            ->first();

        if ($category) {
            return $category->getMetaContentType();
        } else {
            return null;
        }
    }
}

src/Form/DocumentType.php
<?php

namespace App\Form;

use App\Entity\Document;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class DocumentType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('title')
            ->add('docid')
            ->add('categories')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Document::class,
        ]);
    }
}

src/Controller/DocumentController.php
<?php

namespace App\Controller;

use App\Entity\Document;
use App\Entity\Source;
use App\Entity\Version;
use App\Event\FileUpdatedEvent;
use App\Form\UploadType;
use App\Repository\DocumentRepository;
use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ObjectManager;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\File\File;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Validator\Constraints\File as FileConstraint;
use Symfony\Component\Validator\ConstraintViolationInterface;
use Symfony\Component\Validator\Validator\ValidatorInterface;
use Symfony\Contracts\EventDispatcher\EventDispatcherInterface;

/**
 * @Route("/document")
 */
class DocumentController extends AbstractController
{
    /**
     * @Route("/", name="document_index", methods={"GET"})
     */
    public function index(DocumentRepository $documentRepository): Response
    {
        return $this->render('document/index.html.twig', [
            'documents' => $documentRepository->findAll(),
        ]);
    }

    /**
     * @Route("/upload", name="document_upload", methods={"POST"})
     */
    public function upload(Request $request, ValidatorInterface $validator, EntityManagerInterface $manager, EventDispatcherInterface $dispatcher): Response
    {
        if ($file = $request->files->get('file')) {
            /** @var $file UploadedFile */

            $errors = $validator->validate(
                $file,
                new FileConstraint([
                    'maxSize' => '20M',
                    'mimeTypes' => [
                        'application/pdf',
                        'application/x-pdf',
                    ],
                    'mimeTypesMessage' => 'Please upload a valid PDF document'
                ])
            );

            if (count($errors) > 0) {
                return $this->json(array_map(function(ConstraintViolationInterface $error) {
                    return $error->getMessage();
                }, iterator_to_array($errors)), Response::HTTP_BAD_REQUEST);
            }

            $document = new Document();
            $version = new Version();
            $source = new Source();

            $document->setDocid('DOC-001');
            $document->setTitle($file->getClientOriginalName());

            $version->setDocument($document);
            $version->setNumber("1.0");

            $source->setVersion($version);
            $source->setType(Source::InternalType);
            $source->setFile($file);

            $event = new FileUpdatedEvent($source);
            $dispatcher->dispatch($event);

            $manager->persist($document);
            $manager->persist($version);
            $manager->persist($source);
            $manager->flush();

            $this->addFlash('success', 'New document has been uploaded and archived successfully');
            return new Response("Everything is good");
        }

        return $this->json([
            "No file provided"
        ], Response::HTTP_BAD_REQUEST);
    }

    /**
     * @Route("/{id}", name="document_show", methods={"GET"})
     */
    public function show(Document $document): Response
    {
        return $this->render('document/show.html.twig', [
            'document' => $document,
        ]);
    }
}

templates/document/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Document index{% endblock %}

{% block body %}
    <h1>Document index</h1>

    <table class="uk-table uk-table-divider uk-table-responsive uk-text-center uk-text-left@m">
        <thead>
            <tr>
                <th><a class="" href="/mm/docList/?sort=docid">ID</a></th>
                <th><a class="" href="/mm/docList/?sort=subsystem">Subsystem</a></th>
                <th><a class="" href="/mm/docList/?sort=title">Title</a></th>
                <th>Download</th>
                <th class="uk-visible@l">Thumbnail</th>
                <th class="uk-width-medium"><a class="" href="/mm/docList/?sort=author">Author</a></th>
                <th><a class="" href="/mm/docList/?sort=created">Date</a></th>
            </tr>
        </thead>
        <tbody>
        {% for document in documents %}
            <tr>
                <td><code>{{ document.docid }}</code></td>
                <td>{% if document.icon %}
                    <span uk-icon="icon: {{ document.icon }}"></span>
                {% endif %}</td>
                <td colspan="3">
                    <a href="{{ path('document_show', {'id': document.id}) }}" class="uk-link-text">
                        <strong>{{ document.title }}</strong>
                    </a>
                    <div>
                    {% for category in document.categories %}
                        <span class="uk-label {{ category.colour }}">{{ category.name }}</span>
                    {% endfor %}
                    </div>
                </td>
{#                <td></td>#}
{#                <td></td>#}
                <td>{{ document.authors|map(a => a.author.name)|join(", ") }}</td>
                <td>
                    <time>27 August 2019</time>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="4">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

templates/document/show.html.twig
{% extends 'base.html.twig' %}

{% block stylesheets %}
    <link rel="schema.DC" href="http://purl.org/dc/terms/" >
    <link rel="schema.rdf" href="http://purl.org/dc/terms/" >
    <meta name="citation_title" content="{{ document.title }}">
    <meta name="citation_publication_date" content="{{ document.date|date }}">
    {% for author in document.authors %}
        <meta name="citation_author" content="{{ author.author.name }}">
    {% endfor %}
    {% if document.metaContentType %}
        <meta name="rdf:type" content="{{ document.metaContentType }}">
    {% endif %}
{% endblock %}

{% block title %}Document{% endblock %}

{% block top %}
    <header class="uk-panel uk-background-primary uk-light uk-flex uk-flex-middle">
        <aside class="uk-float-left flex-self-expand uk-text-center header-sidelinks">
            <a class="uk-button uk-button-default uk-padding-remove" title="Go back" href="{{ path('document_index') }}">
                <span uk-icon="icon: chevron-left; ratio:2"></span>
            </a><br>
            GO BACK
{#            <a href="{{ path('document_index') }}">back to list</a>#}
        </aside>
        <div class="uk-padding uk-container uk-flex uk-flex-between uk-flex-middle uk-flex-wrap flex-self-expand">
            <h1 class="uk-heading-line uk-heading-small uk-margin-remove-top uk-margin-right" title="Document Title">{{ document.title }}</h1>
            <span class="uk-heading-small uk-text-lead uk-margin-remove-top" title="Document Identifier">{{ document.docid }}</span>

            <div class="flex-separator"></div>

            <span>{{ document.authors|map(a => a.author.name)|join(", ") }}</span>
            <time class="flex-self-top">15 August 2021</time>
        </div>

        <aside class="uk-float-left flex-self-expand uk-text-center header-sidelinks" style="max-width: calc((100vw - 1300px) / 2)">
            <div class="uk-display-inline-block uk-margin-small-left uk-margin-small-right">
                <a class="uk-button uk-button-default uk-padding-remove" title="Permalink" href="{{ path('document_show', { id: document.id }) }}">
                    <span uk-icon="icon: link; ratio:2"></span>
                </a><br>
                PERMALINK
            </div>
            <div class="uk-display-inline-block uk-margin-small-left uk-margin-small-right">
                <a class="uk-button uk-button-default uk-padding-remove" title="Edit" href="{{ path('admin_app_document_edit', { id: document.id }) }}">
                    <span uk-icon="icon: pencil; ratio:2"></span>
                </a><br>
                EDIT
            </div>
        </aside>
    </header>
{% endblock %}

{% block container_start %}
    <div class="uk-flex uk-margin-top uk-flex-around uk-width-expand">
        <aside class="header-sidelinks uk-flex uk-flex-center uk-margin-top">
            <div class="document-sidemenu">
                <ul class="uk-tab-left document-sidemenu" uk-tab="connect: #content-switcher; animation: uk-animation-slide-top-small">
                    <li><a href="#">Document Information</a></li>
                    <li><a href="#">Metadata</a></li>
                </ul>
            </div>
        </aside>
    <main class="uk-container flex-self-expand uk-margin-remove">
{% endblock %}

{% block container_end %}
    </main>
        <aside class="header-sidelinks"></aside>
    </div>
{% endblock %}

{% block body %}
    <div class="uk-switcher" id="content-switcher">
    <div id="document-information" class="uk-child-width-expand@s uk-grid-divider" uk-grid>
        <section class="uk-width-expand@m">
            <h3>Document Information</h3>
            <dl class="uk-description-list">
                <dt>Title</dt>
                <dd>{{ document.title }}</dd>

                <dt>Dates</dt>
                <dd>
                    <div class="uk-child-width-expand@s" uk-grid>
                        <span>Created at <time>{{ document.creationDate|date }}</time></span>
                        <span class="uk-text-right">Last update at <time>{{ document.revisionDate|date }}</time></span>
                    </div>
                </dd>

                <dt>Categories</dt>
                <dd>
                    {% for category in document.categories %}
                        <span class="uk-label {{ category.colour }}">{{ category.name }}</span>
                    {% endfor %}
                </dd>

            </dl>
        </section>
        <section class="uk-width-auto@m">
            <h3>Authors</h3>
            <p>
            <table class="uk-table uk-table-big uk-table-divider">
                <thead>
                <tr>
                    <th>Type</th>
                    <th>Name</th>
                </tr>
                </thead>
                <tbody>
                {% for author in document.authors %}
                    <tr>
                        <td>{{ author.type }}</td>
                        <td>{{ author.author.name }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            </p>
        </section>
    </div>
    <div id="document-metadata" class="uk-child-width-expand@s uk-grid-divider" uk-grid>
        <section class="uk-width-expand@m">
            <h3>Versions</h3>
            <table class="uk-table uk-table-big uk-table-divider">
                <thead>
                <tr>
                    <th>Version Number</th>
                    <th>Date</th>
                    <th>Variant</th>
                </tr>
                </thead>
                <tbody>
                {% for version in document.versions %}
                    <tr>
                        <td>{{ version.number }}</td>
                        <td>{{ version.date|date }}</td>
                        <td>{{ version.variant|join(", ") }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </section>
        <section class="uk-width-auto@m">
            <h3>Metadata</h3>
            <table class="uk-table uk-table-small uk-table-divider">
                <thead>
                <tr>
                    <th>Name</th>
                    <th>Value</th>
                </tr>
                </thead>
                <tbody>
                {% for metadatum in document.latestVersion.metadata %}
                    <tr>
                        <td>{{ metadatum.name }}</td>
                        <td>{{ metadatum.data }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </section>
    </div>
    </div>
{% endblock %}